#[macro_use]
extern crate contracts;
#[macro_use]
extern crate derivative;
#[macro_use]
extern crate tracing;
#[macro_use]
extern crate trace;

use lalrpop_util::lalrpop_mod;

// #[macro_export]
// pub mod fmt;

pub mod abstract_data;
pub mod bidir;
pub mod data;

pub mod bidir_debruijn;
pub mod data_debruijn;

mod gensym;
#[cfg(test)]
mod tests;

lalrpop_mod!(pub parser);

trace::init_depth_var!();
